function Base64() {

	// private property
	_keyStr = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";

	// public method for encoding
	this.encode = function (input) {
		var output = "";
		var chr1, chr2, chr3, enc1, enc2, enc3, enc4;
		var i = 0;
		input = _utf8_encode(input);
		while (i < input.length) {
			chr1 = input.charCodeAt(i++);
			chr2 = input.charCodeAt(i++);
			chr3 = input.charCodeAt(i++);
			enc1 = chr1 >> 2;
			enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
			enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
			enc4 = chr3 & 63;
			if (isNaN(chr2)) {
				enc3 = enc4 = 64;
			} else if (isNaN(chr3)) {
				enc4 = 64;
			}
			output = output +
			_keyStr.charAt(enc1) + _keyStr.charAt(enc2) +
			_keyStr.charAt(enc3) + _keyStr.charAt(enc4);
		}
		return output;
	}

	// public method for decoding
	this.decode = function (input) {
		var output = "";
		var chr1, chr2, chr3;
		var enc1, enc2, enc3, enc4;
		var i = 0;
		input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");
		while (i < input.length) {
			enc1 = _keyStr.indexOf(input.charAt(i++));
			enc2 = _keyStr.indexOf(input.charAt(i++));
			enc3 = _keyStr.indexOf(input.charAt(i++));
			enc4 = _keyStr.indexOf(input.charAt(i++));
			chr1 = (enc1 << 2) | (enc2 >> 4);
			chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
			chr3 = ((enc3 & 3) << 6) | enc4;
			output = output + String.fromCharCode(chr1);
			if (enc3 != 64) {
				output = output + String.fromCharCode(chr2);
			}
			if (enc4 != 64) {
				output = output + String.fromCharCode(chr3);
			}
		}
		output = _utf8_decode(output);
		return output;
	}

	// private method for UTF-8 encoding
	_utf8_encode = function (string) {
		string = string.replace(/\r\n/g,"\n");
		var utftext = "";
		for (var n = 0; n < string.length; n++) {
			var c = string.charCodeAt(n);
			if (c < 128) {
				utftext += String.fromCharCode(c);
			} else if((c > 127) && (c < 2048)) {
				utftext += String.fromCharCode((c >> 6) | 192);
				utftext += String.fromCharCode((c & 63) | 128);
			} else {
				utftext += String.fromCharCode((c >> 12) | 224);
				utftext += String.fromCharCode(((c >> 6) & 63) | 128);
				utftext += String.fromCharCode((c & 63) | 128);
			}

		}
		return utftext;
	}

	// private method for UTF-8 decoding
	_utf8_decode = function (utftext) {
		var string = "";
		var i = 0;
		var c = c1 = c2 = 0;
		while ( i < utftext.length ) {
			c = utftext.charCodeAt(i);
			if (c < 128) {
				string += String.fromCharCode(c);
				i++;
			} else if((c > 191) && (c < 224)) {
				c2 = utftext.charCodeAt(i+1);
				string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
				i += 2;
			} else {
				c2 = utftext.charCodeAt(i+1);
				c3 = utftext.charCodeAt(i+2);
				string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
				i += 3;
			}
		}
		return string;
	}
}

if (typeof jQuery !== "undefined" && typeof saveAs !== "undefined") {
	(function($) {
		$.fn.wordExportPC = function(fileName) {
			fileName = typeof fileName !== 'undefined' ? fileName : "jQuery-Word-Export";
			var static = {
				mhtml: {
					top: "Mime-Version: 1.0\nContent-Type: Multipart/related; boundary=\"NEXT.ITEM-BOUNDARY\";type=\"text/html\"\n\n--NEXT.ITEM-BOUNDARY\nContent-Type: text/html; charset=\"utf-8\"\n<!DOCTYPE html>\n<html>\n_html_</html>",
					head: "<head>\n<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\"> <meta name=\"viewport\" content=\"width=device-width, user-scalable=no, initial-scale=1.0, maximum-scale=1.0, minimum-scale=1.0\">\n<meta http-equiv=\"X-UA-Compatible\" content=\"ie=edge\">\n<xml><w:WordDocument><w:View>Print</w:View></xml><title>Document</title>\n<style>\n_styles_\n</style>\n</head>\n",
					body: "<body>_body_</body>"
				}
			};

			var options = {
				maxWidth: 624
			};
			// Clone selected element before manipulating it
			var markup = $(this).clone();

			// Remove hidden elements from the output
			markup.each(function() {
				var self = $(this);
				if (self.is(':hidden'))
					self.remove();
			});

			// Embed all images using Data URLs
			var images = Array();
			var img = markup.find('img');
			for (var i = 0; i < img.length; i++) {
				// Calculate dimensions of output image
				var w = Math.min(img[i].width, options.maxWidth);
				var h = img[i].height * (w / img[i].width);
				var uri = img[i].src
				var filesrc = "./src" + i + ".png"
				$(img[i]).attr("src",filesrc);
				img[i].width = w;
				img[i].height = h;
				// Save encoded image to array
				images[i] = {
					type: uri.substring(uri.indexOf(":") + 1, uri.indexOf(";")),
					encoding: uri.substring(uri.indexOf(";") + 1, uri.indexOf(",")),
					location: filesrc,
					data: uri.substring(uri.indexOf(",") + 1)
				};
			}
			var resultAll;
			// Prepare bottom of mhtml file with image data
			var mhtmlBottom = "\n";
			for (var i = 0; i < images.length; i++) {
				mhtmlBottom += "--NEXT.ITEM-BOUNDARY\n";
				mhtmlBottom += "Content-Location: " + images[i].location + "\n";
				mhtmlBottom += "Content-Type: " + images[i].type + "\n";
				mhtmlBottom += "Content-Transfer-Encoding: " + images[i].encoding + "\n\n";
				mhtmlBottom += images[i].data + "\n\n";
			}
			mhtmlBottom += "--NEXT.ITEM-BOUNDARY--";

			//TODO: load css from included stylesheet
			var styles = "";
			var baseModel = new Base64();
			var mhtmlBody = "";
			mhtmlBody += "MIME-Version: 1.0\n";
			mhtmlBody += "Content-Type: multipart/related;boundary=\"NEXT.ITEM-BOUNDARY\";type=\"text/html\"\n\n";
			mhtmlBody += "X-MimeOLE: Produced By Mht File Maker v1.0 beta\n";
			mhtmlBody += "This is a multi-part message in MIME format.\n\n";
			mhtmlBody += "--NEXT.ITEM-BOUNDARY\nContent-Type: text/html\nContent-Transfer-Encoding: base64\nContent-Location: tmp.html\n\n";
			mhtmlBody += baseModel.encode("<!doctype html><html xmlns:o=\"urn:schemas-microsoft-com:office:office\"  xmlns:w=\"urn:schemas-microsoft-com:office:word\"  xmlns=\"http://www.w3.org/TR/REC-html40\"><head>    <meta charset=\"UTF-8\">    <meta name=\"viewport\"          content=\"width=device-width, user-scalable=no, initial-scale=1.0, maximum-scale=1.0, minimum-scale=1.0\">    <meta http-equiv=\"X-UA-Compatible\" content=\"ie=edge\">    <xml><w:WordDocument><w:View>Print</w:View></xml>    <title>Document</title></head><body>"+markup.html()+"</body></html>")
			mhtmlBody += "\n\n";
			var fileContent = mhtmlBody + mhtmlBottom;
			return fileContent;
			/*var blob = new Blob([fileContent], {
				type: "application/msword;charset=utf-8"
			});

			saveAs(blob, fileName + ".doc");*/
		};
	})(jQuery);
} else {
	if (typeof jQuery === "undefined") {
		console.error("jQuery Word Export: missing dependency (jQuery)");
	}
   /* if (typeof saveAs === "undefined") {
		console.error("jQuery Word Export: missing dependency (FileSaver.js)");
	}*/
}


if (typeof jQuery !== "undefined" && typeof saveAs !== "undefined") {
    (function($) {
        $.fn.wordExportAndroid = function(fileName) {
            fileName = typeof fileName !== 'undefined' ? fileName : "jQuery-Word-Export";
            var static = {
                mhtml: {
                    top: "Mime-Version: 1.0\nContent-Base: " + location.href + "\nContent-Type: Multipart/related; boundary=\"NEXT.ITEM-BOUNDARY\";type=\"text/html\"\n\n--NEXT.ITEM-BOUNDARY\nContent-Type: text/html; charset=\"utf-8\"\nContent-Location: " + location.href + "\n\n<!DOCTYPE html>\n<html>\n_html_</html>",
                    head: "<head>\n<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n<style>\n_styles_\n</style>\n</head>\n",
                    body: "<body>_body_</body>"
                }
            };
            var options = {
                maxWidth: 624
            };
            // Clone selected element before manipulating it
            var markup = $(this).clone();

            // Remove hidden elements from the output
            markup.each(function() {
                var self = $(this);
                if (self.is(':hidden'))
                    self.remove();
            });

            // Embed all images using Data URLs
            var images = Array();
            var img = markup.find('img');
            for (var i = 0; i < img.length; i++) {
                // Calculate dimensions of output image
                var w = Math.min(img[i].width, options.maxWidth);
                var h = img[i].height * (w / img[i].width);
                // Create canvas for converting image to data URL
                var canvas = document.createElement("CANVAS");
                canvas.width = w;
                canvas.height = h;
                // Draw image to canvas
                var context = canvas.getContext('2d');
                context.drawImage(img[i], 0, 0, w, h);
                // Get data URL encoding of image
                var uri = canvas.toDataURL("image/png");
                $(img[i]).attr("src", img[i].src);
                img[i].width = w;
                img[i].height = h;
                // Save encoded image to array
                images[i] = {
                    type: uri.substring(uri.indexOf(":") + 1, uri.indexOf(";")),
                    encoding: uri.substring(uri.indexOf(";") + 1, uri.indexOf(",")),
                    location: $(img[i]).attr("src"),
                    data: uri.substring(uri.indexOf(",") + 1)
                };
            }

            // Prepare bottom of mhtml file with image data
            var mhtmlBottom = "\n";
            for (var i = 0; i < images.length; i++) {
                mhtmlBottom += "--NEXT.ITEM-BOUNDARY\n";
                mhtmlBottom += "Content-Location: " + images[i].location + "\n";
                mhtmlBottom += "Content-Type: " + images[i].type + "\n";
                mhtmlBottom += "Content-Transfer-Encoding: " + images[i].encoding + "\n\n";
                mhtmlBottom += images[i].data + "\n\n";
            }
            mhtmlBottom += "--NEXT.ITEM-BOUNDARY--";

            //TODO: load css from included stylesheet
            var styles = "";

            // Aggregate parts of the file together
            var fileContent = static.mhtml.top.replace("_html_", static.mhtml.head.replace("_styles_", styles) + static.mhtml.body.replace("_body_", markup.html())) + mhtmlBottom;
               return fileContent;

            // Create a Blob with the file contents
            var blob = new Blob([fileContent], {
                type: "application/msword;charset=utf-8"
            });
            saveAs(blob, fileName + ".doc");
        };
    })(jQuery);
} else {
    if (typeof jQuery === "undefined") {
        console.error("jQuery Word Export: missing dependency (jQuery)");
    }
    if (typeof saveAs === "undefined") {
        console.error("jQuery Word Export: missing dependency (FileSaver.js)");
    }
}

